<template>
  <el-dialog
    v-model="dialogFormVisible"
    :title="title"
    width="500px"
    @close="close"
  >
    <el-form ref="form" :model="form" :rules="rules" label-width="100px">
      <el-form-item label="角色授权" prop="menuIds">
        <el-select
          v-model="form.menuIds"
          size="small"
          multiple
          placeholder="请选择"
        >
          <el-option
            v-for="item in parentData"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          ></el-option>
        </el-select>
      </el-form-item>
    </el-form>
    <div class="dialog-footer">
      <el-button type="primary" size="small" @click="save">确 定</el-button>
      <el-button size="small" @click="close">取 消</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { miniRoleAssignMenu, getMiniRoleMenuIdsByRoleId } from '@/api/role';
import { miniMenuSelect } from '@/api/menu';
export default {
  name: 'RoleGrant',
  data() {
    return {
      form: {
        roleId: '',
        menuIds: '',
      },
      node: [],
      clearable: true,
      parentData: [],
      dialogFormVisible: false,
    };
  },
  created() {},
  methods: {
    async getParentData() {
      const { data } = await miniMenuSelect();
      this.parentData = data;
    },
    async getNodeData() {
      const { data } = await getMiniRoleMenuIdsByRoleId({
        roleId: this.form.roleId,
      });
      this.form.menuIds = data;
    },
    roleGrant(row) {
      this.title = '角色授权';
      this.form = Object.assign({}, row);
      this.form.roleId = row.id;
      this.dialogFormVisible = true;
      this.getNodeData();
      this.getParentData();
    },
    close() {
      this.$refs['form'].resetFields();
      this.form = this.$options.data().form;
      this.dialogFormVisible = false;
      this.$emit('fetch-data');
    },
    save() {
      this.$refs['form'].validate(async valid => {
        if (valid) {
          const { msg } = await miniRoleAssignMenu(this.form);
          this.$notify({
            title: msg,
            type: 'success',
          });
          this.dialogFormVisible = false;
        } else {
          return false;
        }
      });
    },
  },
};
</script>
<style>
.select {
  width: 100%;
}
</style>
